#include "snoop.h"

Snoop*
snoop_new()
{
	int error_flag;
	Snoop *s = (Snoop*)malloc(sizeof(Snoop));
	if (!s) {
		// TODO: put some error policy here.
		error_flag = 1;
		perror("snoop memory allocation failure.");
		return NULL;
	}

	snoop_set_default(s);

	s->main_window = NULL;
	s->image = NULL;
	s->statusbar = NULL;

	s->item_on_top = NULL;
	s->item_grid = NULL;
	s->item_hex_mode = NULL;
	s->item_inverse_y = NULL;
	s->item_center_highlight = NULL;
	s->item_highlight = NULL;
	s->item_filter = NULL;
	s->item_grab_mode = NULL;
	s->item_graph = NULL;

	s->status_cid = -1;
	s->status_mid = -1;

	return s;
}

void
snoop_set_default(Snoop* s){
	s->zoom_factor = 4;
	s->refresh_interval = 100;
	s->on_top = DISABLE;
	s->update = ENABLE;
	s->grid = DISABLE;
	s->hex_mode = DISABLE;
	s->inverse_y = DISABLE;
	s->center_highlight = ENABLE;
	s->filter = NO_FILTER;
	s->graph = NO_GRAPH;
	s->statistics = DISABLE;
	s->ruler = DISABLE;
	s->grab_mode = MOUSE_ARROW_MODE;
	s->width = 300;
	s->height = 300;
	s->red = ENABLE;
	s->green = ENABLE;
	s->blue = ENABLE;
	s->nor_histogram = DISABLE;
	s->nor_gradient = DISABLE;
	s->ref_histogram = 5000;
	s->ref_gradient = 255;
	s->brightness = 0;
	s->contrast = 0;
	s->gamma = 1.0;
}

void
snoop_destroy(Snoop *s)
{
	free(s->item_filter);
	free(s->item_grab_mode);
	free(s->item_graph);
	free(s);
}
